%define section	free

Name:		fractal
Version:	2.2
Release:	1jpp
Epoch:		0
Summary:	A general software composition framework 
License:	LGPL
URL:		http://fractal.objectweb.org/
Group:		Development/Libraries/Java
Vendor:		JPackage Project
Distribution:	JPackage
Source0:	http://download.us.forge.objectweb.org/fractal/FractalALL-2.2.zip
# FIXME: For now I am including a binary jar until I can find out what version
# of jonathan this is. To make matters worse, the jonathan project is defunct.
#Source1:	jonathan.jar
Requires:	antlr
Requires:	asm
BuildRequires:	ant
BuildRequires:	antlr
BuildRequires:	asm
BuildRequires:	jpackage-utils >= 0:1.5
BuildRequires:	monolog
BuildRequires:	owanttask
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
Fractal is a general software composition framework that supports
component-based programming, including components (type) definition,
configuration, composition and administration.

%package	javadoc
Summary:	Javadoc for %{name}
Group:		Development/Documentation

%description	javadoc
Javadoc for %{name}.

%prep
%setup -q -n FractalALL
# TODO: package cldc, even if used here unly as reference for j2me-converter
CLDC_JAR=$(find . -name cldc.jar)
mv ${CLDC_JAR} ${CLDC_JAR}.sav
find . -name "*.jar" -exec rm -f {} \;
mv ${CLDC_JAR}.sav ${CLDC_JAR}
## fractal
pushd fractal/config/
ln -sf $(build-classpath owanttask) ow_util_ant_tasks.jar
popd
## fractaladl
pushd fractaladl/config/
ln -sf $(build-classpath owanttask) ow_util_ant_tasks.jar
popd
pushd fractaladl/externals/
ln -sf $(build-classpath asm/asm) .
ln -sf $(build-classpath dtdparser) .
ln -sf ../../fractal/output/dist/lib/fractal.jar .
ln -sf $(build-classpath owdeploysched/ow_deployment_scheduling) .
ln -sf $(build-classpath monolog/ow_util_log_api) .
popd
## fractalrmi
pushd fractalrmi/config/
ln -sf $(build-classpath owanttask) ow_util_ant_tasks.jar
popd
pushd fractalrmi/externals/
ln -sf $(build-classpath asm/asm) .
ln -sf $(build-classpath dtdparser) .
ln -sf ../../fractaladl/output/dist/lib/fractal-adl.jar .
ln -sf ../../fractal/output/dist/lib/fractal.jar .
ln -sf $(build-classpath owdeploysched/ow_deployment_scheduling) .
ln -sf $(build-classpath monolog/ow_util_log_api) .
popd
## fractalswing
pushd fractalswing/config/
ln -sf $(build-classpath owanttask) ow_util_ant_tasks.jar
popd
pushd fractalswing/externals/
ln -sf ../../fractal/output/dist/lib/fractal.jar .
popd
## fractalgui
pushd fractalgui/config/
ln -sf $(build-classpath owanttask) ow_util_ant_tasks.jar
popd
pushd fractalgui/externals/
ln -sf $(build-classpath asm/asm) .
ln -sf $(build-classpath dtdparser) .
ln -sf ../../fractaladl/output/dist/lib/fractal-adl.jar .
ln -sf ../../fractalrmi/output/dist/lib/fractal-rmi-tmpl.jar .
ln -sf ../../fractalrmi/output/dist/lib/fractal-rmi.jar .
ln -sf ../../fractalswing/output/dist/lib/fractal-swing.jar .
ln -sf ../../fractal/output/dist/lib/fractal.jar .
ln -sf $(build-classpath owdeploysched/ow_deployment_scheduling) .
ln -sf ../../fractalrmi/output/dist/lib/jonathan.jar .
ln -sf $(build-classpath gvf/gvf-cwi-svggraphics) SVGGraphics.jar
popd
## julia
pushd julia/config/
ln -sf $(build-classpath owanttask) ow_util_ant_tasks.jar
popd
pushd julia/externals/
ln -sf $(build-classpath asm/asm) .
ln -sf ../../fractal/output/dist/lib/fractal.jar .
ln -sf $(build-classpath monolog/ow_monolog) .
popd
## fractaljmx
pushd fractaljmx/config/
ln -sf $(build-classpath owanttask) ow_util_ant_tasks.jar
popd
pushd fractaljmx/externals/
ln -sf $(build-classpath asm/asm) .
ln -sf $(build-classpath dtdparser) .
ln -sf ../../fractaladl/output/dist/lib/fractal-adl.jar .
ln -sf ../../fractal/output/dist/lib/fractal.jar .
ln -sf $(build-classpath jmxri) .
ln -sf $(build-classpath jmxtools) .
ln -sf ../../julia/output/dist/lib/julia-asm.jar .
ln -sf ../../julia/output/dist/lib/julia-mixins.jar .
ln -sf ../../julia/output/dist/lib/julia-runtime.jar .
ln -sf $(build-classpath owdeploysched/ow_deployment_scheduling) .
popd

%build
for d in fractal fractaladl fractalrmi fractalswing fractalgui; do
    pushd $d
    ant -Dbuild.compiler=modern test dist
    popd
done
pushd julia
ant -Dbuild.compiler=modern -Dtest.type=conform test dist
popd
pushd fractaljmx
ant -Dbuild.compiler=modern test dist
popd
pushd examples
ant 
popd

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}

for jar in */output/dist/lib/*.jar; do
install -m 644 ${jar} $RPM_BUILD_ROOT%{_javadir}/%{name}/`basename ${jar} .jar`-%{version}.jar
done

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do \
ln -sf ${jar} ${jar/-%{version}/}; done)

# javadoc
install -p -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr */output/dist/doc/javadoc/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
(cd $RPM_BUILD_ROOT%{_javadocdir} && ln -sf %{name}-%{version} %{name})

%clean
rm -rf $RPM_BUILD_ROOT
rm -rf $RPM_BUILD_DIR/Fractal

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ $1 -eq 0 ]; then
  rm -f %{_javadocdir}/%{name}
fi

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar

%files javadoc
%defattr(0644,root,root,0755)
%dir %{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}-%{version}/*
%ghost %dir %{_javadocdir}/%{name}

%changelog
* Tue Sep 21 2004 Ralph Apel <r.apel at r-apel.de> 0:2.2-1jpp
- Upgrade to 2.2
- Now contains fractal/jonathan.jar (from fractal sources :-)
- Require owanttask (not contained in monolog any more)
- Still require monolog
- Require owdeploysched 
- Require gvf (for gvf/gvf-cwi-svggraphics.jar)
- License is LGPL

* Mon Aug 23 2004 Ralph Apel <r.apel at r-apel.de> 0:2.0-2jpp
- Build with ant-1.6.2
- Set build.compiler to modern

* Thu Jan 22 2004 David Walluck <david@anti-microsoft.org> 0:2.0-1jpp
- release
